package com.jiuqi.dna.ide.designer.commands;

import com.jiuqi.dna.ide.designer.DesignerMessages;
import com.jiuqi.dna.ide.designer.elements.ICompositeElement;
import com.jiuqi.dna.ide.designer.elements.IDesignerElement;
import org.eclipse.gef.commands.Command;

/* loaded from: com_jiuqi_dna_ide_designer_commands.jar:com/jiuqi/dna/ide/designer/commands/CompositeReparentChildCommand.class */
public class CompositeReparentChildCommand extends Command {
    private ICompositeElement parent;
    private IDesignerElement child;
    private ICompositeElement before;

    public CompositeReparentChildCommand(ICompositeElement parent, IDesignerElement child) {
        this.parent = parent;
        this.child = child;
        this.before = child.getParent();
        setLabel(DesignerMessages.ReparentChildCommandLabel);
    }

    public boolean canExecute() {
        return this.parent != this.before;
    }

    public void execute() {
        this.child.dispose();
        this.child.setParent(this.parent);
        this.child.init();
    }

    public void undo() {
        this.child.dispose();
        this.child.setParent(this.before);
        this.child.init();
    }
}
