package com.jiuqi.dna.ide.designer.commands;

import com.jiuqi.dna.ide.designer.DesignerMessages;
import com.jiuqi.dna.ide.designer.elements.IDesignerElement;
import com.jiuqi.dna.ide.designer.elements.Property;
import org.eclipse.gef.commands.Command;

/* loaded from: com_jiuqi_dna_ide_designer_commands.jar:com/jiuqi/dna/ide/designer/commands/DesignerElementChangePropertyCommand.class */
public class DesignerElementChangePropertyCommand extends Command {
    private IDesignerElement element;
    private Property property;
    private String oldValue;

    public DesignerElementChangePropertyCommand(IDesignerElement element, Property property) {
        this.element = element;
        this.property = property;
        setLabel(DesignerMessages.DesignerElementChangePropertyCommandLabel);
    }

    public boolean canExecute() {
        return (this.element == null || this.property == null || !this.element.canModifyProperty(this.property.getName())) ? false : true;
    }

    public void execute() {
        this.oldValue = this.element.getPropertyValue(this.property.getName());
        this.element.setPropertyValue(this.property.getName(), this.property.getValue());
    }

    public void undo() {
        this.element.setPropertyValue(this.property.getName(), this.oldValue);
    }
}
